// rsupv_loop_exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rsupv_loop_example.h"
#include "rsupv_loop_exampleDlg.h"
#include "resource.h"
#include "rsupv.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRsupv_loop_exampleDlg dialog

CRsupv_loop_exampleDlg::CRsupv_loop_exampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRsupv_loop_exampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRsupv_loop_exampleDlg)
	m_Volume = 1.0;
	m_IDQuery = TRUE;
	m_Reset = TRUE;
	m_Ress = _T("GPIB::20");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRsupv_loop_exampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRsupv_loop_exampleDlg)
	DDX_Control(pDX, IDC_DATA, m_CData);
	DDX_Text(pDX, IDC_VOLUME, m_Volume);
	DDX_Check(pDX, IDC_ID_QUERY, m_IDQuery);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Text(pDX, IDC_RESOURCE_DESCRIPTOR, m_Ress);
//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRsupv_loop_exampleDlg, CDialog)
	//{{AFX_MSG_MAP(CRsupv_loop_exampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDSTART, OnStart)
	ON_EN_KILLFOCUS(IDC_VOLUME, OnKillfocusVolume)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRsupv_loop_exampleDlg message handlers

BOOL CRsupv_loop_exampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	// Init Table
	m_CData.InsertColumn (0, _T("Frequency"), LVCFMT_LEFT, 80);
	m_CData.InsertColumn (1, _T("Values"), LVCFMT_LEFT, 100);
	m_CData.InsertColumn (2, _T("Units"), LVCFMT_LEFT, 60);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRsupv_loop_exampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRsupv_loop_exampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRsupv_loop_exampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//Provide operation after button Start is pressed
void CRsupv_loop_exampleDlg::OnStart() 
{
	ViStatus	rsupv_status;
	ViSession	instrSession;
	ViChar		buffer[512];
	ViReal64	value;
    ViChar		unit[10];
	CString		str_buf;
	ViReal64	freq;
	long		i;

	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	
	UpdateData();

    /* Initialize the driver */
	rsupv_status = rsupv_init((char *) ((LPCTSTR) m_Ress), (int)(m_IDQuery), (int)(m_Reset), &instrSession);
	if (rsupv_status < 0)
	{
		AfxMessageBox ("Could not open the session!", MB_OK);
		cur = LoadCursor ( NULL, IDC_ARROW );
		SetCursor ( cur );
		return;
	}
    // config trigger
	FT_CHECKERR (rsupv_SetMeasurementMode (instrSession, VI_FALSE), "rsupv_SetMeasurementMode");
    // config universal analog generator
    FT_CHECKERR (rsupv_ConfigureGeneratorAnalog (instrSession,
                                                  RSUPV_GEN_CH_21,
                                                  RSUPV_GEN_OUTPUT_UNBAL,
                                                  RSUPV_GEN_IMPEDANCE_10,
                                                  RSUPV_GEN_OUTPUT_COMM_GND,
                                                  RSUPV_GEN_BWIDTH_22,
                                                  RSUPV_GEN_VOLT_RANG_AUTO,
                                                  10.0, RSUPV_UNIT_V), "rsupv_ConfigureGeneratorAnalog");
    // Configure Generator Reference
    FT_CHECKERR (rsupv_ConfigureGeneratorReference (instrSession, 10.0, 
													RSUPV_UNIT_V, 1.0e3,
													RSUPV_UNIT_HZ), "rsupv_ConfigureGeneratorReference");
    // Set Generator Function
    FT_CHECKERR (rsupv_SetGeneratorFunction (instrSession, RSUPV_GEN_FUNC_SINE), "rsupv_SetGeneratorFunction");
    // Set Generator Sine Low Distortion
    FT_CHECKERR (rsupv_SetGeneratorSineLowDistortion (instrSession, VI_FALSE), "rsupv_SetGeneratorSineLowDistortion");
    // Set Generator DC Offset
    FT_CHECKERR (rsupv_SetGeneratorDCOffset (instrSession, VI_FALSE), "rsupv_SetGeneratorDCOffset");
    // Set Generator Voltage
    FT_CHECKERR (rsupv_SetGeneratorVoltage (instrSession, 1, 1.0, RSUPV_UNIT_V), "rsupv_SetGeneratorVoltage");
    // Set Generator Frequency
	FT_CHECKERR (rsupv_SetGeneratorFrequency (instrSession, 1, 1000.0, RSUPV_UNIT_HZ), "rsupv_SetGeneratorFrequency");
	// Set Analyzer Channel Input
	FT_CHECKERR (rsupv_SetAnalyzerChannelInput (instrSession, 1, RSUPV_ANALYZER_CH_INPUT_BAL), "rsupv_SetAnalyzerChannelInput");
    // Set Analyzer Ref Impedance
	FT_CHECKERR (rsupv_SetAnalyzerRefImpedance (instrSession, 600.0), "rsupv_SetAnalyzerRefImpedance");
    // Set Analyzer Channel Input Range
	FT_CHECKERR (rsupv_SetAnalyzerChannelInputRange (instrSession, 1, RSUPV_ANALYZER_CH_INPUT_RANGE_AUTO), "rsupv_SetAnalyzerChannelInputRange");
    // Set Analyzer Channel Input Common
	FT_CHECKERR (rsupv_SetAnalyzerChannelInputCommon (instrSession, 1, RSUPV_ANALYZER_CH_INPUT_COMMON_FLOAT), "rsupv_SetAnalyzerChannelInputCommon");
    //Generator Ch1: Internal connection of analyzer channel 1 to generator output 1. The analyzer input impedance is 200 kOhm.
	FT_CHECKERR (rsupv_SetAnalyzerChannelInput (instrSession, 1, RSUPV_ANALYZER_CH_INPUT_BAL), "rsupv_SetAnalyzerChannelInput");
	// Set Analyzer Level Meas Time
	FT_CHECKERR (rsupv_SetAnalyzerLevelMeasTime (instrSession, RSUPV_ANALYZER_MEAS_TIME_AFAS), "rsupv_SetAnalyzerLevelMeasTime");
	// Configure Analyzer Notch Filter
	FT_CHECKERR (rsupv_ConfigureAnalyzerNotchFilter (instrSession, RSUPV_ANALYZER_NOTCH_GAIN_OFF,
                                                 RSUPV_ANALYZER_NOTCH_FREQ_FIX, 10.0), "rsupv_ConfigureAnalyzerNotchFilter");
	// Set Analyzer Filter
	FT_CHECKERR (rsupv_SetAnalyzerFilter (instrSession, 1, RSUPV_ANALYZER_PREFILTER_OFF), "rsupv_SetAnalyzerFilter");            
    // Set Analyzer Function
	FT_CHECKERR (rsupv_SetAnalyzerFunction (instrSession, RSUPV_ANALYZER_FUNC_RMS), "rsupv_SetAnalyzerFunction");
	// Set Unit    
	FT_CHECKERR (rsupv_SetAnalyzerUnit (instrSession, 1, RSUPV_ANALYZER_MEASUREMENT_FUNC, RSUPV_UNIT_DBV), "rsupv_SetAnalyzerUnit");
	// Set Aux Speaker
	FT_CHECKERR (rsupv_SetAuxSpeaker (instrSession, VI_FALSE), "rsupv_SetAuxSpeaker");
    // Set Aux Monitoring Channel
	FT_CHECKERR (rsupv_SetAuxMonitoringChannel (instrSession, RSUPV_AUX_CHANNEL_CH1), "rsupv_SetAuxMonitoringChannel");
	// Set Generator Volume
	FT_CHECKERR (rsupv_SetGeneratorVoltage (instrSession, 1, m_Volume, RSUPV_UNIT_V), "rsupv_SetGeneratorVoltage");
	// For Loop controlling frequency sweep
    for (i = 0; i <= 100; i++) {
		freq=pow(10.0,(i/50.0+2.0));
		FT_CHECKERR (rsupv_SetGeneratorModulationFrequency(instrSession,freq, RSUPV_UNIT_HZ), "rsupv_SetGeneratorModulationFrequency");
		FT_CHECKERR (rsupv_StartMeasurementWaitOPC (instrSession, 15000),"rsupv_StartMeasurementWaitOPC");
		FT_CHECKERR (rsupv_ReadMeasurementResult (instrSession, 1, RSUPV_MEASUREMENT_FUNCTION, &value, unit), "rsupv_ReadMeasurementResult");
	   // display measured data
		str_buf.Format("%7.1f Hz",freq);
		InsertRow (i, str_buf,value,unit);
		UpdateData();
	}            
	rsupv_close(instrSession);
	cur = LoadCursor ( NULL, IDC_ARROW);
	SetCursor ( cur );
}

//Inserts a row to the List	
void CRsupv_loop_exampleDlg::InsertRow(long index, CString name, double value, CString unit)
{
	CString text;	
	text.Format("%3.2f",value);
	if (m_CData.GetItemCount() > index){
		m_CData.SetItem(index, 0, LVIF_TEXT, name, 0, 0, 0, 0);
		m_CData.SetItem(index, 1, LVIF_TEXT, (LPCTSTR)text, 0, 0, 0, 0);
		m_CData.SetItem(index, 2, LVIF_TEXT, unit, 0, 0, 0, 0);
	}
	else
	{
		m_CData.InsertItem(index, name);
		m_CData.SetItemText(index,1,(LPCTSTR)text);
		m_CData.SetItemText(index,2,(LPCTSTR)unit);
	}
}

void CRsupv_loop_exampleDlg::OnKillfocusVolume() 
{
	double	min;
	double	max;
	CString message;

	min = 0.0;
	max = 10.0;

	UpdateData(TRUE);
	if ((m_Volume <min) || (m_Volume >max))
	{
		message.Format("Please enter value in range %lf to %lf!",min,max);
		AfxMessageBox (message, MB_OK);
		m_Volume = min;
		UpdateData(FALSE);
	}	
}
